/*
 *	pasteproc.c
 *		PasteDIB֐̈pfnPasteProcɓnĎg֐łB
 *		Rɓ]pĂč\܂B
 *		ńAPASTEPROC^Ō^LXgsĉB
 *		: PasteDIB(hDIBDest, 0, 0, 100, 100, hDIBSrc, 0, 0, (PASTEPROC)AlphaPaste, 50);
 */

#include <windows.h>
#include <stdlib.h>
#include "imgctl.h"

/*
 *	AlphaPaste
 *		At@ufBOs܂B
 *		\tɔœ\t܂B
 *		PasteDIB̈lParamŁAx 0 ` ALPHA_MAX Ŏw肵ĉB
 *		ALPHA_MAX ͕ύX\ŁAl傫قǓɂȂ܂B
 */
#define ALPHA_MAX	100
COLORREF CALLBACK AlphaPaste(LPPASTEINFO lppi)
{
	DWORD dwCol;
	BYTE r, g, b;

	dwCol = (DWORD)GetRValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetRValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	r = (BYTE)(dwCol / ALPHA_MAX);
	dwCol = (DWORD)GetGValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetGValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	g = (BYTE)(dwCol / ALPHA_MAX);
	dwCol = (DWORD)GetBValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetBValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	b = (BYTE)(dwCol / ALPHA_MAX);

	return RGB(r, g, b);
}

/*
 *	SpritePaste
 *		XvCg(F)s܂B
 *		̐F͓\tȂ悤ɏo܂B
 *		PasteDIB̈lParamŁAFCOLORREF^Ŏw肵ĉB
 */
COLORREF CALLBACK SpritePaste(LPPASTEINFO lppi)
{
	return ((lppi->colSrc == (COLORREF)lppi->lParam) ? lppi->colDest : lppi->colSrc);
}

/*
 *	FramePaste (for v1.10B or later)
 *		zɃAt@ufBOs܂B
 *		摜̊OقǓx̍\tɂȂ܂B
 *		PasteDIB̈lParamŁAz̕sNZPʂŎw肵ĉB
 *		ȂA AlphaPaste ŗp܂B
 */
COLORREF CALLBACK FramePaste(LPPASTEINFO lppi)
{
	long n[3];

	/* [̋̍ŏl߂ */
	n[0] = labs(lppi->lXDest - lppi->rcArea.left);
	n[1] = labs(lppi->lXDest - lppi->rcArea.right);
	n[0] = min(n[0], n[1]);
	n[1] = labs(lppi->lYDest - lppi->rcArea.top);
	n[2] = labs(lppi->lYDest - lppi->rcArea.bottom);
	n[1] = min(n[1], n[2]);
	n[0] = min(n[0], n[1]);

	/* L͈͓ȂAt@ufBO */
	if (n[0] < lppi->lParam) {
		lppi->lParam = ALPHA_MAX - (ALPHA_MAX * (n[0] + 1)) / (lppi->lParam + 1);
		lppi->colSrc = AlphaPaste(lppi);
	}

	return lppi->colSrc;
}

/*
 *	PngAlphaPaste (for v1.10B or later)
 *		PNGAtoDIBŎ擾At@`lf[^p܂B
 *		PasteDIB̈lParamŁA֐̈hDIBSrc̃At@`l
 *		HDIB^Ŏw肵ĉB
 *		ÃAt@`lf[^ł\܂B
 */
COLORREF CALLBACK PngAlphaPaste(LPPASTEINFO lppi)
{
	LPCIMGDATA pImg;
	long lLength;
	BYTE alpha;
	DWORD dwCol;
	BYTE r, g, b;

	/* At@`lf[^擾 */
	pImg = DataDIB((HDIB)lppi->lParam);
	if (!pImg) { return lppi->colSrc; }
	lLength = (((pImg->pbmi->bmiHeader.biWidth << 3) + 31) >> 5) << 2;
	alpha = *(pImg->pData + lppi->lXSrc +
		(pImg->pbmi->bmiHeader.biHeight - lppi->lYSrc - 1) * lLength);

	/* At@ufBO */
	dwCol = (DWORD)GetRValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetRValue(lppi->colSrc) * alpha;
	r = (BYTE)(dwCol / 255);
	dwCol = (DWORD)GetGValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetGValue(lppi->colSrc) * alpha;
	g = (BYTE)(dwCol / 255);
	dwCol = (DWORD)GetBValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetBValue(lppi->colSrc) * alpha;
	b = (BYTE)(dwCol / 255);

	return RGB(r, g, b);
}
